## mingw-w64-serial-studio-3.2.1-1.src.tar.zst

=== CMakeLists.txt ===
#
# Serial Studio
# https://serial-studio.com/
#
# Copyright (C) 2020–2025 Alex Spataru
#
# This file is dual-licensed:
#
# - Under the GNU GPLv3 (or later) for builds that exclude Pro modules.
# - Under the Serial Studio Commercial License for builds that include
#   any Pro functionality.
#
# You must comply with the terms of one of these licenses, depending
# on your use case.
#
# For GPL terms, see <https://www.gnu.org/licenses/gpl-3.0.html>
# For commercial terms, see LICENSE_COMMERCIAL.md in the project root.
#
# SPDX-License-Identifier: GPL-3.0-only OR LicenseRef-SerialStudio-Commercial
#

cmake_minimum_required(VERSION 3.20)

#-------------------------------------------------------------------------------
# Define project name & find Qt packages for correct CPack calls
#-------------------------------------------------------------------------------

project(Serial-Studio LANGUAGES CXX)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(
   Qt6 REQUIRED
   COMPONENTS
   Core
   Qml
)

#-------------------------------------------------------------------------------
# Options for build types
#-------------------------------------------------------------------------------

option(BUILD_GPL3              "Force GPLv3-only build"                 ON)
option(DEBUG_SANITIZER         "Enable sanitizers for debug builds"    OFF)
option(PRODUCTION_OPTIMIZATION "Enable production optimization flags"  OFF)
option(BUILD_COMMERCIAL        "Enable commercial features"            OFF)
option(USE_SYSTEM_ZLIB         "Use system-provided zlib instead of downloading from GitHub" OFF)
option(USE_SYSTEM_EXPAT        "Use system-provided expat instead of downloading from GitHub" OFF)

set(ARCGIS_API_KEY $ENV{ARCGIS_API_KEY} CACHE STRING "API Key for ArcGIS map")
set(SERIAL_STUDIO_LICENSE_KEY $ENV{SERIAL_STUDIO_LICENSE_KEY} CACHE STRING "License key for commercial build")
set(SERIAL_STUDIO_INSTANCE_ID $ENV{SERIAL_STUDIO_INSTANCE_ID} CACHE STRING "Instance ID for license validation")

#-------------------------------------------------------------------------------
# Project information
#-------------------------------------------------------------------------------

set(PROJECT_ROOT_DIR ${CMAKE_CURRENT_LIST_DIR})

if(BUILD_COMMERCIAL)
   set(PROJECT_DISPNAME "Serial Studio Pro")
   set(PROJECT_FILE_LICENSE "${PROJECT_ROOT_DIR}/LICENSES/LicenseRef-SerialStudio-Commercial.txt")
   if (UNIX AND NOT APPLE)
      set(PROJECT_EXECUTABLE "serial-studio-pro")
   else()
      set(PROJECT_EXECUTABLE "Serial-Studio-Pro")
   endif()
else()
   set(PROJECT_DISPNAME "Serial Studio GPLv3")
   set(PROJECT_FILE_LICENSE "${PROJECT_ROOT_DIR}/LICENSES/GPL-3.0-only.txt")
   if (UNIX AND NOT APPLE)
      set(PROJECT_EXECUTABLE "serial-studio-gpl3")
   else()
      set(PROJECT_EXECUTABLE "Serial-Studio-GPL3")
   endif()
endif()

set(PROJECT_VENDOR              "Alex Spataru")
set(PROJECT_CONTACT             "serial-studio.github.io")
set(PROJECT_DESCRIPTION_SUMMARY "Flexible data visualization software for embedded devices and projects")
set(PROJECT_VERSION_MAJOR       "3")
set(PROJECT_VERSION_MINOR       "2")
set(PROJECT_VERSION_PATCH       "1")
set(PROJECT_VERSION             "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
set(PROJECT_APPCAST             "https://raw.githubusercontent.com/Serial-Studio/Serial-Studio/master/updates.json")
set(PROJECT_DESCRIPTION_FILE    "${PROJECT_ROOT_DIR}/README.md")
set(PROJECT_FILE_NAME           "${PROJECT_EXECUTABLE}-v${PROJECT_VERSION}")

#-------------------------------------------------------------------------------
# Allow source code to access project information
#-------------------------------------------------------------------------------

add_definitions(-DPROJECT_VENDOR="${PROJECT_VENDOR}")
add_definitions(-DPROJECT_CONTACT="${PROJECT_CONTACT}")
add_definitions(-DPROJECT_VERSION="${PROJECT_VERSION}")
add_definitions(-DPROJECT_APPCAST="${PROJECT_APPCAST}")
add_definitions(-DPROJECT_DISPNAME="${PROJECT_DISPNAME}")
add_definitions(-DPROJECT_DESCRIPTION_SUMMARY="${PROJECT_DESCRIPTION_SUMMARY}")

#-------------------------------------------------------------------------------
# Licensing and validation
#-------------------------------------------------------------------------------

if(BUILD_GPL3)
   if(BUILD_COMMERCIAL)
      message(FATAL_ERROR
         "You cannot enable commercial features (BUILD_COMMERCIAL=ON) when BUILD_GPL3=ON.\n"
         "Set -DBUILD_GPL3=OFF to build with commercial modules.")
   endif()

   set(BUILD_COMMERCIAL OFF CACHE BOOL "Commercial features disabled due to GPLv3 build mode" FORCE)
   message(STATUS "BUILD_GPL3=ON, enforcing BUILD_COMMERCIAL=OFF for license compliance")
endif()

if(BUILD_COMMERCIAL)
    add_compile_definitions(BUILD_COMMERCIAL)
    add_definitions(-DARCGIS_API_KEY="${ARCGIS_API_KEY}")
    message(STATUS "BUILD_COMMERCIAL=ON, validating license with Lemon Squeezy")

    if(NOT SERIAL_STUDIO_LICENSE_KEY OR NOT SERIAL_STUDIO_INSTANCE_ID)
        message(FATAL_ERROR
            "Missing SERIAL_STUDIO_LICENSE_KEY or SERIAL_STUDIO_INSTANCE_ID.\n"
            "Pass them via -D flags or set them as environment variables.")
    endif()

    find_program(CURL_EXECUTABLE curl)
    if(NOT CURL_EXECUTABLE)
        message(FATAL_ERROR "curl not found in PATH, required to validate license.")
    endif()

    execute_process(
        COMMAND curl -s -X POST https://api.lemonsqueezy.com/v1/licenses/validate
        -H "Accept: application/vnd.api+json"
        -H "Content-Type: application/vnd.api+json"
        -d "{\"license_key\": \"${SERIAL_STUDIO_LICENSE_KEY}\", \"instance_id\": \"${SERIAL_STUDIO_INSTANCE_ID}\"}"
        OUTPUT_VARIABLE LS_RESPONSE
        ERROR_VARIABLE LS_ERROR
        RESULT_VARIABLE LS_RESULT
    )

    if(NOT LS_RESULT EQUAL 0)
        message(FATAL_ERROR "License validation failed: ${LS_ERROR}")
    endif()

    string(FIND "${LS_RESPONSE}" "\"valid\":true" VALID_POS)
    if(VALID_POS EQUAL -1)
        message(FATAL_ERROR
            "Commercial build denied: License not valid or not active.\n"
            "Response: ${LS_RESPONSE}")
    endif()

    message(STATUS "License validation succeeded, building with commercial features")
endif()

#-------------------------------------------------------------------------------
# Log CPU type
#-------------------------------------------------------------------------------

message(STATUS "CMAKE_SYSTEM_PROCESSOR: ${CMAKE_SYSTEM_PROCESSOR}")

#-------------------------------------------------------------------------------
# Set UNIX friendly name for app & fix OpenSUSE builds
#-------------------------------------------------------------------------------

if (UNIX AND NOT APPLE)
   set(CMAKE_C_COMPILER_AR "/usr/bin/ar")
   set(CMAKE_CXX_COMPILER_AR "/usr/bin/ar")
   set(CMAKE_C_COMPILER_RANLIB "/usr/bin/ranlib")
   set(CMAKE_CXX_COMPILER_RANLIB "/usr/bin/ranlib")
endif()

#-------------------------------------------------------------------------------
# Set compiler warnings
#-------------------------------------------------------------------------------

if(MSVC)
  add_compile_options(
    /wd4324                        # Structure padding warning
    /wd4267                        # size_t to int conversion warning
  )
else()
  add_compile_options(
    -Wall                          # Enable common warning messages
    -Wextra                        # Enable extra warnings
    -Wno-unused-function           # Silence miniaudio warnings
  )
endif()

#-------------------------------------------------------------------------------
# Production optimization flags
#-------------------------------------------------------------------------------

if(PRODUCTION_OPTIMIZATION)
   # Detect sandboxed build environments (Flathub) and disable LTO
   if(USE_SYSTEM_ZLIB OR USE_SYSTEM_EXPAT)
      set(DISABLE_LTO ON)
      message(STATUS "Sandboxed build detected (USE_SYSTEM_ZLIB or USE_SYSTEM_EXPAT), disabling LTO")
   else()
      set(DISABLE_LTO OFF)
   endif()

   # Print status
   message("Enabling production optimization flags for modern hardware (2012+)...")

   # Add NDEBUG definition for all configurations
   add_compile_definitions(NDEBUG)

   # LLVM (MinGW) on Windows
   if(WIN32 AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND MINGW)
      add_compile_options(
         -O3                             # Aggressive optimization
         -march=x86-64-v2                # Target modern CPUs (2012+) with SSE4.2
         -ftree-vectorize                # Enable automatic vectorization
         -funroll-loops                  # Improve loop performance by unrolling
         -fomit-frame-pointer            # Optimize function call overhead
         -fno-fast-math                  # IEEE-compliant floating point
         -fno-unsafe-math-optimizations  # Avoid unsafe math assumptions
         -finline-functions              # Inline functions where possible
         -ffunction-sections             # Place each function in its own section
         -fdata-sections                 # Place each data item in its own section
      )
      if(NOT DISABLE_LTO)
         add_compile_options(-flto=auto) # Link-time optimization with parallelization
      endif()
      add_link_options(
         -Wl,--gc-sections               # Remove unused functions/data from final binary
      )
      if(NOT DISABLE_LTO)
         add_link_options(-flto=auto)    # Enable LTO at link time
      endif()
   
   # GCC (MinGW) on Windows
   elseif(WIN32 AND MINGW)
      add_compile_options(
         -O3                             # Aggressive optimization
         -march=x86-64-v2                # Target modern CPUs (2012+) with SSE4.2
         -ftree-vectorize                # Enable automatic vectorization
         -funroll-loops                  # Improve loop performance by unrolling
         -fomit-frame-pointer            # Optimize function call overhead
         -frename-registers              # Better instruction scheduling
         -fno-fast-math                  # IEEE-compliant floating point
         -fno-unsafe-math-optimizations  # Avoid unsafe math assumptions
         -fstack-reuse=all               # Reuse stack slots
         -finline-functions              # Inline functions where possible
         -ffunction-sections             # Place each function in its own section
         -fdata-sections                 # Place each data item in its own section
      )
      if(NOT DISABLE_LTO)
         add_compile_options(-flto=auto) # Link-time optimization with parallelization
      endif()
      add_link_options(
         -Wl,--gc-sections               # Remove unused code/data at link time
      )
      if(NOT DISABLE_LTO)
         add_link_options(-flto=auto)    # Enable LTO at link time
      endif()

   # MSVC (Visual Studio)
   elseif(WIN32 AND MSVC)
      add_compile_options(
         /permissive-                    # Enforce strict ISO C++ conformance
         /Zc:__cplusplus                 # Set __cplusplus to actual version value
         /Zc:preprocessor                # Standards-compliant preprocessor
         /MP                             # Enable multi-core compilation
         /O2                             # Optimize for speed
         /Ot                             # Favor fast code over small code
         /W4                             # High warning level
         /fp:precise                     # IEEE-accurate floating-point math
         /Qpar                           # Enable automatic parallelization of loops
         /Gw                             # Put functions/data into separate COMDATs
         /DNDEBUG                        # Disable assertions
      )
      if(NOT DISABLE_LTO)
         add_compile_options(/GL)        # Enable whole program optimization
      endif()
      add_link_options(
         /OPT:REF                        # Remove unreferenced functions/data

=== app/CMakeLists.txt ===
#
# Serial Studio
# https://serial-studio.com/
#
# Copyright (C) 2020–2025 Alex Spataru
#
# This file is dual-licensed:
#
# - Under the GNU GPLv3 (or later) for builds that exclude Pro modules.
# - Under the Serial Studio Commercial License for builds that include
#   any Pro functionality.
#
# You must comply with the terms of one of these licenses, depending
# on your use case.
#
# For GPL terms, see <https://www.gnu.org/licenses/gpl-3.0.html>
# For commercial terms, see LICENSE_COMMERCIAL.md in the project root.
#
# SPDX-License-Identifier: GPL-3.0-only OR LicenseRef-SerialStudio-Commercial
#

#-------------------------------------------------------------------------------
# Project setup
#-------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.20)
project(app LANGUAGES CXX VERSION ${PROJECT_VERSION})

#-------------------------------------------------------------------------------
# C++ options
#-------------------------------------------------------------------------------

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#-------------------------------------------------------------------------------
# Add external dependencies (Qt)
#-------------------------------------------------------------------------------

# Specify required modules for FOSS version
set(QT_MODULES
  Svg
  Gui
  Qml
  Sql
  Core
  Quick
  Graphs
  Widgets
  Bluetooth
  SerialPort
  Core5Compat
  LinguistTools
  QuickControls2
)

# Specify required libraries for FOSS version
set(QT_LIBS
  Qt6::Core
  Qt6::Svg
  Qt6::Sql
  Qt6::Gui
  Qt6::Qml
  Qt6::Quick
  Qt6::Graphs
  Qt6::Widgets
  Qt6::Bluetooth
  Qt6::SerialPort
  Qt6::Core5Compat
  Qt6::QuickControls2
)

# Add required modules for Pro version if needed
if(BUILD_COMMERCIAL)
  set(QT_MODULES
    ${QT_MODULES}
    Mqtt
    SerialBus
  )
  set(QT_LIBS
    ${QT_LIBS}
    Qt6::Mqtt
    Qt6::SerialBus
  )
endif()

# Find the Qt package and its modules
find_package(
  Qt6 REQUIRED
  COMPONENTS
  ${QT_MODULES}
)

# Qt project setup & policies
qt_standard_project_setup()
qt_policy(SET QTP0001 NEW)
qt_policy(SET QTP0002 NEW)
qt_policy(SET QTP0004 NEW)

#-------------------------------------------------------------------------------
# Import source code
#-------------------------------------------------------------------------------

include_directories(src)

# Specify required sources for FOSS version
set(SOURCES
  src/Misc/ThemeManager.cpp
  src/Misc/CommonFonts.cpp
  src/Misc/Utilities.cpp
  src/Misc/Translator.cpp
  src/Misc/ModuleManager.cpp
  src/Misc/TimerEvents.cpp
  src/Misc/WorkspaceManager.cpp
  src/UI/DashboardWidget.cpp
  src/UI/Dashboard.cpp
  src/UI/Taskbar.cpp
  src/UI/WindowManager.cpp
  src/UI/WidgetRegistry.cpp
  src/UI/Widgets/LEDPanel.cpp
  src/UI/Widgets/Gauge.cpp
  src/UI/Widgets/Plot.cpp
  src/UI/Widgets/Compass.cpp
  src/UI/Widgets/Bar.cpp
  src/UI/Widgets/FFTPlot.cpp
  src/UI/Widgets/Accelerometer.cpp
  src/UI/Widgets/DataGrid.cpp
  src/UI/Widgets/Terminal.cpp
  src/UI/Widgets/Gyroscope.cpp
  src/UI/Widgets/GPS.cpp
  src/UI/Widgets/MultiPlot.cpp
  src/UI/DeclarativeWidgets/DeclarativeWidget.cpp
  src/UI/DeclarativeWidgets/StaticTable.cpp
  src/Plugins/Server.cpp
  src/IO/Drivers/Network.cpp
  src/IO/Drivers/UART.cpp
  src/IO/Drivers/BluetoothLE.cpp
  src/IO/Checksum.cpp
  src/Console/Handler.cpp
  src/IO/Manager.cpp
  src/Console/Export.cpp
  src/IO/FileTransmission.cpp
  src/IO/FrameReader.cpp
  src/JSON/FrameParser.cpp
  src/JSON/ProjectModel.cpp
  src/JSON/FrameBuilder.cpp
  src/JSON/Frame.cpp
  src/JSON/FrameParserTestDialog.cpp
  src/CSV/Player.cpp
  src/CSV/Export.cpp
  src/MDF4/Player.cpp
  src/MDF4/Export.cpp
  src/main.cpp
  src/SerialStudio.cpp
)

# Specify required headers for FOSS version
set(HEADERS
  src/Misc/ModuleManager.h
  src/Misc/Utilities.h
  src/Misc/CommonFonts.h
  src/Misc/ThemeManager.h
  src/Misc/TimerEvents.h
  src/Misc/Translator.h
  src/Misc/WorkspaceManager.h
  src/UI/Dashboard.h
  src/UI/DashboardWidget.h
  src/UI/Taskbar.h
  src/UI/WindowManager.h
  src/UI/WidgetRegistry.h
  src/UI/Widgets/GPS.h
  src/UI/Widgets/MultiPlot.h
  src/UI/Widgets/Gauge.h
  src/UI/Widgets/Plot.h
  src/UI/Widgets/DataGrid.h
  src/UI/Widgets/FFTPlot.h
  src/UI/Widgets/Gyroscope.h
  src/UI/Widgets/Bar.h
  src/UI/Widgets/Accelerometer.h
  src/UI/Widgets/LEDPanel.h
  src/UI/Widgets/Compass.h
  src/UI/Widgets/Terminal.h
  src/UI/DeclarativeWidgets/DeclarativeWidget.h
  src/UI/DeclarativeWidgets/StaticTable.h
  src/Plugins/Server.h
  src/Platform/NativeWindow.h
  src/Console/Handler.h
  src/IO/Drivers/UART.h
  src/IO/Drivers/Network.h
  src/IO/Drivers/BluetoothLE.h
  src/IO/Manager.h
  src/IO/HAL_Driver.h
  src/IO/Checksum.h
  src/Console/Export.h
  src/IO/CircularBuffer.h
  src/IO/FileTransmission.h
  src/IO/FrameReader.h
  src/JSON/FrameParser.h
  src/JSON/ProjectModel.h
  src/JSON/Frame.h
  src/JSON/FrameBuilder.h
  src/JSON/FrameParserTestDialog.h
  src/CSV/Export.h
  src/CSV/Player.h
  src/MDF4/Player.h
  src/MDF4/Export.h
  src/ThirdParty/atomicops.h
  src/ThirdParty/readerwriterqueue.h
  src/ThirdParty/readerwritercircularbuffer.h
  src/AppInfo.h
  src/DSP.h
  src/SerialStudio.h
)

# Specify required QML files for FOSS version
set(QML_SOURCES
  qml/Dialogs/About.qml
  qml/Dialogs/Acknowledgements.qml
  qml/Dialogs/CsvPlayer.qml
  qml/Dialogs/Mdf4Player.qml
  qml/Dialogs/Donate.qml
  qml/Dialogs/FileTransmission.qml
  qml/Dialogs/IconPicker.qml
  qml/Dialogs/Settings.qml
  qml/Dialogs/Welcome.qml
  qml/MainWindow/Panes/Dashboard/DashboardCanvas.qml
  qml/MainWindow/Panes/Dashboard/StartMenu.qml
  qml/MainWindow/Panes/Dashboard/Taskbar.qml
  qml/MainWindow/Panes/Dashboard/WidgetDelegate.qml
  qml/MainWindow/Panes/SetupPanes/Drivers/BluetoothLE.qml
  qml/MainWindow/Panes/SetupPanes/Drivers/Network.qml
  qml/MainWindow/Panes/SetupPanes/Drivers/UART.qml
  qml/MainWindow/Panes/SetupPanes/Hardware.qml
  qml/MainWindow/Panes/Console.qml
  qml/MainWindow/Panes/Dashboard.qml
  qml/MainWindow/Panes/Setup.qml
  qml/MainWindow/Panes/Toolbar.qml
  qml/MainWindow/MainWindow.qml
  qml/ProjectEditor/Sections/ProjectStructure.qml
  qml/ProjectEditor/Sections/ProjectToolbar.qml
  qml/ProjectEditor/Views/ActionView.qml
  qml/ProjectEditor/Views/DatasetView.qml
  qml/ProjectEditor/Views/FrameParserView.qml
  qml/ProjectEditor/Views/GroupView.qml
  qml/ProjectEditor/Views/ProjectView.qml
  qml/ProjectEditor/Views/TableDelegate.qml
  qml/ProjectEditor/ProjectEditor.qml
  qml/Widgets/Dashboard/Accelerometer.qml
  qml/Widgets/Dashboard/Bar.qml
  qml/Widgets/Dashboard/Compass.qml
  qml/Widgets/Dashboard/DataGrid.qml
  qml/Widgets/Dashboard/FFTPlot.qml
  qml/Widgets/Dashboard/Gauge.qml
  qml/Widgets/Dashboard/GPS.qml
  qml/Widgets/Dashboard/Gyroscope.qml
  qml/Widgets/Dashboard/LEDPanel.qml
  qml/Widgets/Dashboard/MultiPlot.qml
  qml/Widgets/Dashboard/Plot.qml
  qml/Widgets/Dashboard/Terminal.qml
  qml/Widgets/BigButton.qml
  qml/Widgets/InfoBullet.qml
  qml/Widgets/JSONDropArea.qml
  qml/Widgets/MenuButton.qml
  qml/Widgets/MiniWindow.qml
  qml/Widgets/Pane.qml
  qml/Widgets/PlotWidget.qml
  qml/Widgets/ProNotice.qml
  qml/Widgets/SmartWindow.qml
  qml/Widgets/SubMenuCombo.qml
  qml/Widgets/TaskbarButton.qml
  qml/Widgets/ToolbarButton.qml
  qml/Widgets/VisualRange.qml
  qml/DialogLoader.qml
  qml/main.qml
)

# Add commercial source files
if(BUILD_COMMERCIAL)
  set(HEADERS
    ${HEADERS}
    src/MQTT/Client.h
    src/IO/Drivers/Audio.h
    src/IO/Drivers/CANBus.h
    src/IO/Drivers/Modbus.h
    src/UI/Widgets/Plot3D.h
    src/JSON/DBCImporter.h
    src/Licensing/Trial.h
    src/Licensing/MachineID.h
    src/Licensing/SimpleCrypt.h
    src/Licensing/LemonSqueezy.h
    src/ThirdParty/miniaudio.h
  )
  set(SOURCES
    ${SOURCES}
    src/MQTT/Client.cpp
    src/IO/Drivers/Audio.cpp
    src/IO/Drivers/CANBus.cpp
    src/IO/Drivers/Modbus.cpp
    src/UI/Widgets/Plot3D.cpp
    src/JSON/DBCImporter.cpp
    src/Licensing/Trial.cpp
    src/ThirdParty/miniaudio.cpp
    src/Licensing/MachineID.cpp
    src/Licensing/SimpleCrypt.cpp
    src/Licensing/LemonSqueezy.cpp
  )
  set(QML_SOURCES
    ${QML_SOURCES}
    qml/Dialogs/LicenseManagement.qml
    qml/Dialogs/MQTTConfiguration.qml
    qml/MainWindow/Panes/SetupPanes/Drivers/Audio.qml
    qml/MainWindow/Panes/SetupPanes/Drivers/CANBus.qml
    qml/MainWindow/Panes/SetupPanes/Drivers/Modbus.qml
    qml/MainWindow/Panes/SetupPanes/Drivers/ModbusGroupsDialog.qml
    qml/MainWindow/Panes/SetupPanes/Drivers/DBCPreviewDialog.qml
    qml/Widgets/Dashboard/Plot3D.qml
  )
endif()

#-------------------------------------------------------------------------------
# Platform-specific configuration
#-------------------------------------------------------------------------------

if(WIN32)
  set(SOURCES
    ${SOURCES}
    "${CMAKE_CURRENT_SOURCE_DIR}/deploy/windows/info.rc"
    "src/Platform/CSD.cpp"
    "src/Platform/NativeWindow_CSD.cpp"
  )
  set(HEADERS
    ${HEADERS}
    "src/Platform/CSD.h"
  )
elseif(APPLE)
  if(BUILD_COMMERCIAL)
    set(INFO_MACOSX "${CMAKE_CURRENT_SOURCE_DIR}/deploy/macOS/info-pro.plist")
  else()
    set(INFO_MACOSX "${CMAKE_CURRENT_SOURCE_DIR}/deploy/macOS/info-gpl3.plist")
  endif()

  set(ICON_MACOSX "${CMAKE_CURRENT_SOURCE_DIR}/deploy/macOS/AppIcon.icns")
  set(ASSETS_MACOSX "${CMAKE_CURRENT_SOURCE_DIR}/deploy/macOS/Assets.car")

  set_source_files_properties(
    ${ICON_MACOSX}
    ${ASSETS_MACOSX}
    PROPERTIES MACOSX_PACKAGE_LOCATION "Resources"
  )

  set(SOURCES
    ${SOURCES}
    ${ICON_MACOSX}
    ${ASSETS_MACOSX}
    "src/Platform/NativeWindow_macOS.mm"
  )

  set_source_files_properties("src/Platform/NativeWindow_macOS.mm" 
    PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON
  )
elseif(UNIX)
  set(SOURCES
    ${SOURCES}
    "src/Platform/CSD.cpp"
    "src/Platform/NativeWindow_CSD.cpp"
  )
  set(HEADERS
    ${HEADERS}
    "src/Platform/CSD.h"
  )
endif()

#-------------------------------------------------------------------------------
# Add resources
#-------------------------------------------------------------------------------

qt_add_resources(RES_RCC ${CMAKE_CURRENT_SOURCE_DIR}/rcc/rcc.qrc)
qt_add_resources(QTR_RCC ${CMAKE_CURRENT_SOURCE_DIR}/translations/translations.qrc)

#-------------------------------------------------------------------------------
# Create executable
#-------------------------------------------------------------------------------

qt_add_executable(
  ${PROJECT_EXECUTABLE}
  ${SOURCES}
  ${HEADERS}
  ${QML_RCC}
  ${RES_RCC}
  ${QTR_RCC}
  ${QT_RCC_TRANSLATIONS}
  ${APP_RCC_TRANSLATIONS}
  MANUAL_FINALIZATION
)

target_link_libraries(
  ${PROJECT_EXECUTABLE} PUBLIC

  ${QT_LIBS}

  kissfft
  QCodeEditor
  QSimpleUpdater
  mdf
)

target_link_openssl(
  ${PROJECT_EXECUTABLE}
  ${CMAKE_CURRENT_SOURCE_DIR}/../lib/OpenSSL
)

#-------------------------------------------------------------------------------
# Add QML code and precompile it
#-------------------------------------------------------------------------------

qt_add_qml_module(
  ${PROJECT_EXECUTABLE}
  URI gui
  VERSION 1.0
  QML_FILES ${QML_SOURCES}
  RESOURCE_PREFIX /serial-studio.com/
)

#-------------------------------------------------------------------------------
# MiniAudio configuration
#-------------------------------------------------------------------------------

if (BUILD_COMMERCIAL)
  target_compile_definitions(${PROJECT_EXECUTABLE} PRIVATE
    MA_NO_DECODING
    MA_NO_ENCODING
    MA_NO_WAV
    MA_NO_FLAC
    MA_NO_MP3
    MA_NO_RESOURCE_MANAGER
    MA_NO_NODE_GRAPH
    MA_NO_ENGINE
    MA_NO_GENERATION
    MA_NO_CUSTOM
    MA_NO_NULL
  )

  if(LINUX)
    target_link_libraries(${PROJECT_EXECUTABLE} PRIVATE asound)
  endif()

  if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(x86_64|amd64)$")
    target_compile_definitions(${PROJECT_EXECUTABLE} PRIVATE MA_SUPPORT_SSE2)
  endif()

  if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm64|aarch64)$" AND NOT APPLE)

=== lib/CMakeLists.txt ===
#
# Serial Studio
# https://serial-studio.com/
#
# Copyright (C) 2020–2025 Alex Spataru
#
# This file is dual-licensed:
#
# - Under the GNU GPLv3 (or later) for builds that exclude Pro modules.
# - Under the Serial Studio Commercial License for builds that include
#   any Pro functionality.
#
# You must comply with the terms of one of these licenses, depending
# on your use case.
#
# For GPL terms, see <https://www.gnu.org/licenses/gpl-3.0.html>
# For commercial terms, see LICENSE_COMMERCIAL.md in the project root.
#
# SPDX-License-Identifier: GPL-3.0-only OR LicenseRef-SerialStudio-Commercial
#

cmake_minimum_required(VERSION 3.20)

#-------------------------------------------------------------------------------
# Include FetchContent module
#-------------------------------------------------------------------------------

include(FetchContent)
set(FETCHCONTENT_QUIET ON)
if(UNIX)
  set(CMAKE_FIND_LIBRARY_SUFFIXES ".a" ${CMAKE_FIND_LIBRARY_SUFFIXES})
endif()

#-------------------------------------------------------------------------------
# Compiler flags for third-party libraries
#-------------------------------------------------------------------------------

if(MSVC)
  set(LIB_FLAGS
    /w                          # Suppress all warnings
    /Zc:inline                  # Remove unreferenced inline functions
    /Gy                         # Enable function-level linking
  )
else()
  set(LIB_FLAGS
    -w                          # Suppress all warnings
    -fvisibility=hidden         # Hide all symbols
    -fvisibility-inlines-hidden # Hide C++ inline function symbols
  )
  set(LIB_LINK_FLAGS
    -fvisibility=hidden         # Hide all symbols at link time
  )
endif()

#-------------------------------------------------------------------------------
# ZLIB: Use system library or download from GitHub
#-------------------------------------------------------------------------------

if(USE_SYSTEM_ZLIB)
  message(STATUS "Using system-provided ZLIB")
  find_package(ZLIB REQUIRED)

  if(NOT TARGET ZLIB::ZLIB)
    message(FATAL_ERROR "System ZLIB not found. Install zlib development package or set USE_SYSTEM_ZLIB=OFF")
  endif()

  message(STATUS "System ZLIB found: ${ZLIB_VERSION_STRING}")
else()
  message(STATUS "Fetching ZLIB 1.3.1 from GitHub...")

  FetchContent_Declare(
    zlib
    GIT_REPOSITORY https://github.com/madler/zlib.git
    GIT_TAG        v1.3.1
    GIT_SHALLOW    TRUE
    GIT_PROGRESS   FALSE
  )

  set(BUILD_SHARED_LIBS   OFF CACHE INTERNAL "Build static libraries" FORCE)
  set(ZLIB_BUILD_EXAMPLES OFF CACHE BOOL     "Build zlib examples"    FORCE)
  set(SKIP_INSTALL_ALL    ON  CACHE BOOL     "Skip zlib installation" FORCE)

  FetchContent_MakeAvailable(zlib)

  target_compile_options(zlibstatic PRIVATE ${LIB_FLAGS})
  if(NOT MSVC AND LIB_LINK_FLAGS)
    target_link_options(zlibstatic PRIVATE ${LIB_LINK_FLAGS})
  endif()

  if(NOT TARGET ZLIB::ZLIB)
    add_library(ZLIB::ZLIB ALIAS zlibstatic)
    set(ZLIB_FOUND TRUE CACHE INTERNAL "ZLIB found via FetchContent")
    set(ZLIB_INCLUDE_DIRS "${zlib_SOURCE_DIR};${zlib_BINARY_DIR}" CACHE INTERNAL "ZLIB include directories")
    set(ZLIB_LIBRARIES zlibstatic CACHE INTERNAL "ZLIB libraries")
    set(ZLIB_VERSION_STRING "1.3.1" CACHE INTERNAL "ZLIB version")
  endif()

  message(STATUS "ZLIB 1.3.1 fetched and configured")
endif()

#-------------------------------------------------------------------------------
# EXPAT: Use system library or download from GitHub
#-------------------------------------------------------------------------------

if(USE_SYSTEM_EXPAT)
  message(STATUS "Using system-provided EXPAT")
  find_package(EXPAT REQUIRED)

  if(NOT TARGET expat::expat)
    if(TARGET EXPAT::EXPAT)
      add_library(expat::expat ALIAS EXPAT::EXPAT)
    else()
      message(FATAL_ERROR "System EXPAT not found. Install expat development package or set USE_SYSTEM_EXPAT=OFF")
    endif()
  endif()

  message(STATUS "System EXPAT found: ${EXPAT_VERSION_STRING}")
else()
  message(STATUS "Fetching EXPAT 2.6.4 from GitHub...")

  FetchContent_Declare(
    expat
    GIT_REPOSITORY https://github.com/libexpat/libexpat.git
    GIT_TAG        R_2_6_4
    GIT_SHALLOW    TRUE
    GIT_PROGRESS   FALSE
    SOURCE_SUBDIR  expat
  )

  set(EXPAT_SHARED_LIBS     OFF CACHE BOOL "Build shared libraries"  FORCE)
  set(EXPAT_BUILD_DOCS      OFF CACHE BOOL "Build documentation"     FORCE)
  set(EXPAT_BUILD_EXAMPLES  OFF CACHE BOOL "Build examples"          FORCE)
  set(EXPAT_BUILD_TESTS     OFF CACHE BOOL "Build tests"             FORCE)
  set(EXPAT_BUILD_TOOLS     OFF CACHE BOOL "Build tools"             FORCE)
  set(EXPAT_BUILD_FUZZERS   OFF CACHE BOOL "Build fuzzers"           FORCE)
  set(EXPAT_BUILD_PKGCONFIG OFF CACHE BOOL "Build pkg-config file"   FORCE)
  set(EXPAT_ENABLE_INSTALL  OFF CACHE BOOL "Skip expat installation" FORCE)

  FetchContent_MakeAvailable(expat)

  target_compile_options(expat PRIVATE ${LIB_FLAGS})
  if(NOT MSVC AND LIB_LINK_FLAGS)
    target_link_options(expat PRIVATE ${LIB_LINK_FLAGS})
  endif()

  if(TARGET expat AND NOT TARGET expat::expat)
    add_library(expat::expat ALIAS expat)
    set(EXPAT_FOUND TRUE CACHE INTERNAL "EXPAT found via FetchContent")
    set(EXPAT_INCLUDE_DIRS "${expat_SOURCE_DIR}/expat/lib" CACHE INTERNAL "EXPAT include directories")
    set(EXPAT_LIBRARIES expat CACHE INTERNAL "EXPAT libraries")
  endif()

  message(STATUS "EXPAT 2.6.4 fetched and configured")
endif()

#-------------------------------------------------------------------------------
# Compile local libraries
#-------------------------------------------------------------------------------

add_subdirectory(OpenSSL)
add_subdirectory(KissFFT)
add_subdirectory(QCodeEditor)
add_subdirectory(QSimpleUpdater)
add_subdirectory(mdflib)

#-------------------------------------------------------------------------------
# Apply flags to internal libraries
#-------------------------------------------------------------------------------

if(TARGET kissfft)
  target_compile_options(kissfft PRIVATE ${LIB_FLAGS})
  if(NOT MSVC AND LIB_LINK_FLAGS)
    target_link_options(kissfft PRIVATE ${LIB_LINK_FLAGS})
  endif()
endif()

if(TARGET QCodeEditor)
  target_compile_options(QCodeEditor PRIVATE ${LIB_FLAGS})
  if(NOT MSVC AND LIB_LINK_FLAGS)
    target_link_options(QCodeEditor PRIVATE ${LIB_LINK_FLAGS})
  endif()
endif()

if(TARGET QSimpleUpdater)
  target_compile_options(QSimpleUpdater PRIVATE ${LIB_FLAGS})
  if(NOT MSVC AND LIB_LINK_FLAGS)
    target_link_options(QSimpleUpdater PRIVATE ${LIB_LINK_FLAGS})
  endif()
endif()

if(TARGET mdf)
  target_compile_options(mdf PRIVATE ${LIB_FLAGS})
  if(NOT MSVC AND LIB_LINK_FLAGS)
    target_link_options(mdf PRIVATE ${LIB_LINK_FLAGS})
  endif()
endif()

=== tests/CMakeLists.txt ===
#
# Serial Studio
# https://serial-studio.com/
#
# Copyright (C) 2020–2025 Alex Spataru
#
# This file is dual-licensed:
#
# - Under the GNU GPLv3 (or later) for builds that exclude Pro modules.
# - Under the Serial Studio Commercial License for builds that include
#   any Pro functionality.
#
# You must comply with the terms of one of these licenses, depending
# on your use case.
#
# For GPL terms, see <https://www.gnu.org/licenses/gpl-3.0.html>
# For commercial terms, see LICENSE_COMMERCIAL.md in the project root.
#
# SPDX-License-Identifier: GPL-3.0-only OR LicenseRef-SerialStudio-Commercial
#

cmake_minimum_required(VERSION 3.20)
project(SerialStudioTests LANGUAGES CXX VERSION ${PROJECT_VERSION})

#-------------------------------------------------------------------------------
# C++ options
#-------------------------------------------------------------------------------

set(CMAKE_AUTOMOC ON)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#-------------------------------------------------------------------------------
# Find Qt Test module
#-------------------------------------------------------------------------------

find_package(Qt6 REQUIRED COMPONENTS Test Core Qml Widgets)

#-------------------------------------------------------------------------------
# Enable CTest
#-------------------------------------------------------------------------------

enable_testing()

#-------------------------------------------------------------------------------
# Common include directories
#-------------------------------------------------------------------------------

include_directories(
  ${CMAKE_SOURCE_DIR}/app/src
  ${CMAKE_SOURCE_DIR}/lib
)

#-------------------------------------------------------------------------------
# Helper function to create and register tests
#-------------------------------------------------------------------------------

function(add_serial_studio_test test_name)
  add_executable(${test_name} ${ARGN})

  target_link_libraries(${test_name}
    Qt6::Test
    Qt6::Core
    Qt6::Qml
    Qt6::Widgets
  )

  add_test(NAME ${test_name} COMMAND ${test_name})

  set_target_properties(${test_name} PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/tests
  )
endfunction()

#-------------------------------------------------------------------------------
# Copy test fixtures to build directory
#-------------------------------------------------------------------------------

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/fixtures
     DESTINATION ${CMAKE_BINARY_DIR}/tests)

#-------------------------------------------------------------------------------
# IO Module Tests
#-------------------------------------------------------------------------------

# Test: Checksum algorithms
add_serial_studio_test(test_checksum
  IO/test_checksum.cpp
  ${CMAKE_SOURCE_DIR}/app/src/IO/Checksum.cpp
)

# Test: Checksum fuzzy testing
add_serial_studio_test(test_checksum_fuzz
  IO/test_checksum_fuzz.cpp
  ${CMAKE_SOURCE_DIR}/app/src/IO/Checksum.cpp
)

# Test: Circular buffer
add_serial_studio_test(test_circular_buffer
  IO/test_circular_buffer.cpp
)

# Test: Fixed queue
add_serial_studio_test(test_fixed_queue
  IO/test_fixed_queue.cpp
)

# Test: Frame reader
add_serial_studio_test(test_frame_reader
  IO/test_frame_reader.cpp
  ${CMAKE_SOURCE_DIR}/app/src/IO/FrameReader.cpp
  ${CMAKE_SOURCE_DIR}/app/src/IO/Checksum.cpp
  ${CMAKE_SOURCE_DIR}/app/src/SerialStudio.cpp
)

# Test: Console
add_serial_studio_test(test_console
  IO/test_console.cpp
  ${CMAKE_SOURCE_DIR}/app/src/IO/Console.cpp
  ${CMAKE_SOURCE_DIR}/app/src/IO/CircularBuffer.h
)

#-------------------------------------------------------------------------------
# JSON Module Tests
#-------------------------------------------------------------------------------

# Test: Frame structures
add_serial_studio_test(test_frame
  JSON/test_frame.cpp
  ${CMAKE_SOURCE_DIR}/app/src/JSON/Frame.cpp
  ${CMAKE_SOURCE_DIR}/app/src/SerialStudio.cpp
)

# Test: Frame serialization
add_serial_studio_test(test_frame_serialization
  JSON/test_frame_serialization.cpp
  ${CMAKE_SOURCE_DIR}/app/src/JSON/Frame.cpp
  ${CMAKE_SOURCE_DIR}/app/src/SerialStudio.cpp
)

# Test: Frame deserialization
add_serial_studio_test(test_frame_deserialization
  JSON/test_frame_deserialization.cpp
  ${CMAKE_SOURCE_DIR}/app/src/JSON/Frame.cpp
  ${CMAKE_SOURCE_DIR}/app/src/SerialStudio.cpp
)

# Test: Frame utilities
add_serial_studio_test(test_frame_utilities
  JSON/test_frame_utilities.cpp
  ${CMAKE_SOURCE_DIR}/app/src/JSON/Frame.cpp
  ${CMAKE_SOURCE_DIR}/app/src/SerialStudio.cpp
)

# Test: Frame builder
add_serial_studio_test(test_frame_builder
  JSON/test_frame_builder.cpp
  ${CMAKE_SOURCE_DIR}/app/src/JSON/FrameBuilder.cpp
  ${CMAKE_SOURCE_DIR}/app/src/JSON/Frame.cpp
  ${CMAKE_SOURCE_DIR}/app/src/JSON/FrameParser.cpp
  ${CMAKE_SOURCE_DIR}/app/src/SerialStudio.cpp
)

# Test: Project model
add_serial_studio_test(test_project_model
  JSON/test_project_model.cpp
  ${CMAKE_SOURCE_DIR}/app/src/JSON/ProjectModel.cpp
  ${CMAKE_SOURCE_DIR}/app/src/JSON/Frame.cpp
  ${CMAKE_SOURCE_DIR}/app/src/SerialStudio.cpp
)

#-------------------------------------------------------------------------------
# Misc Module Tests
#-------------------------------------------------------------------------------

# Test: Utilities
add_serial_studio_test(test_utilities
  Misc/test_utilities.cpp
  ${CMAKE_SOURCE_DIR}/app/src/Misc/Utilities.cpp
)

# Test: Translator
add_serial_studio_test(test_translator
  Misc/test_translator.cpp
  ${CMAKE_SOURCE_DIR}/app/src/Misc/Translator.cpp
)

# Test: Theme manager
add_serial_studio_test(test_theme_manager
  Misc/test_theme_manager.cpp
  ${CMAKE_SOURCE_DIR}/app/src/Misc/ThemeManager.cpp
)

#-------------------------------------------------------------------------------
# DSP Module Tests
#-------------------------------------------------------------------------------

# Test: DSP processing (disabled - DSP.cpp not found)
# add_serial_studio_test(test_dsp
#   DSP/test_dsp.cpp
# )

#-------------------------------------------------------------------------------
# CSV Module Tests
#-------------------------------------------------------------------------------

# Test: CSV export
add_serial_studio_test(test_export
  CSV/test_export.cpp
  ${CMAKE_SOURCE_DIR}/app/src/CSV/Export.cpp
  ${CMAKE_SOURCE_DIR}/app/src/JSON/Frame.cpp
  ${CMAKE_SOURCE_DIR}/app/src/SerialStudio.cpp
)

#-------------------------------------------------------------------------------
# Licensing Module Tests
#-------------------------------------------------------------------------------

# Test: SimpleCrypt
add_serial_studio_test(test_simple_crypt
  Licensing/test_simple_crypt.cpp
  ${CMAKE_SOURCE_DIR}/app/src/Licensing/SimpleCrypt.cpp
)

# Test: MachineID
add_serial_studio_test(test_machine_id
  Licensing/test_machine_id.cpp
  ${CMAKE_SOURCE_DIR}/app/src/Licensing/MachineID.cpp
)

#-------------------------------------------------------------------------------
# Test summary
#-------------------------------------------------------------------------------

message(STATUS "Configured ${CMAKE_CURRENT_SOURCE_DIR} with ${CMAKE_BUILD_TYPE} build type")

=== lib/KissFFT/CMakeLists.txt ===
# Directory for easier includes
# Anywhere you see include(...) you can check <root>/cmake for that file
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

#
# Extract version from Makefile
#

file(READ Makefile _MAKEFILE_CONTENTS)

string(REGEX MATCH "KFVER_MAJOR = ([0-9]+)\n" KFVER_MAJOR_MATCH "${_MAKEFILE_CONTENTS}")
if(NOT KFVER_MAJOR_MATCH)
    message(FATAL_ERROR "Cannot extract major (ABI) version from Makefile")
endif()
set(KFVER_MAJOR "${CMAKE_MATCH_1}")

string(REGEX MATCH "KFVER_MINOR = ([0-9]+)\n" KFVER_MINOR_MATCH "${_MAKEFILE_CONTENTS}")
if(NOT KFVER_MINOR_MATCH)
    message(FATAL_ERROR "Cannot extract minor version from Makefile")
endif()
set(KFVER_MINOR "${CMAKE_MATCH_1}")

string(REGEX MATCH "KFVER_PATCH = ([0-9]+)\n" KFVER_PATCH_MATCH "${_MAKEFILE_CONTENTS}")
if(NOT KFVER_PATCH_MATCH)
    message(FATAL_ERROR "Cannot extract patch version from Makefile")
endif()
set(KFVER_PATCH "${CMAKE_MATCH_1}")

set(MAKEFILE_EXTRACTED_VERSION "${KFVER_MAJOR}.${KFVER_MINOR}.${KFVER_PATCH}")

#
# Declare CMake project
#

cmake_minimum_required(VERSION 3.6)
project(kissfft VERSION "${MAKEFILE_EXTRACTED_VERSION}")

#
# CMake configuration options
#

# Principal datatype: double, float (default), int16_t, int32_t, simd

set(KISSFFT_DATATYPE "float" CACHE STRING "Principal datatype of kissfft: double, float (default), int16_t, int32_t, simd")

# Additional options

option(KISSFFT_OPENMP "Build kissfft with OpenMP support" OFF)
option(KISSFFT_PKGCONFIG "Build pkg-config files" OFF)
option(KISSFFT_STATIC "Build kissfft as static (ON) or shared library (OFF)" ON)
option(KISSFFT_TEST "Build kissfft tests" OFF)
option(KISSFFT_TOOLS "Build kissfft command-line tools" OFF)
option(KISSFFT_USE_ALLOCA "Use alloca instead of malloc" OFF)

#
# Validate datatype
#

if (NOT KISSFFT_DATATYPE MATCHES "^double$" AND
    NOT KISSFFT_DATATYPE MATCHES "^float$" AND
    NOT KISSFFT_DATATYPE MATCHES "^int16_t$" AND
    NOT KISSFFT_DATATYPE MATCHES "^int32_t$" AND
    NOT KISSFFT_DATATYPE MATCHES "^simd$")
    message(FATAL_ERROR "Incorrect value of KISSFFT_DATATYPE! It can be one of: double, float, int16_t, int32_t, simd")
endif()

#
# Print principal datatype
#

message(STATUS "Building KissFFT with datatype: ${KISSFFT_DATATYPE}")
set(KISSFFT_OUTPUT_NAME "kissfft-${KISSFFT_DATATYPE}")

#
# Validate KISSFFT_STATIC
#

if (BUILD_SHARED_LIBS AND KISSFFT_STATIC)
    message(FATAL_ERROR "Conflicting CMake configuration: -DBUILD_SHARED_LIBS=ON and -DKISSFFT_STATIC=ON")
endif()

#
# Enable BUILD_SHARED_LIBS for shared library build before
# kissfft library is declared
#

if (NOT KISSFFT_STATIC)
    set(BUILD_SHARED_LIBS ON)
    message(STATUS "Building shared library")
else()
    message(STATUS "Building static library")
endif()

#
# Detect C compiler and pass appropriate flags
#

if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang|AppleClang")
    add_compile_options(-ffast-math -fomit-frame-pointer
        -W -Wall -Wcast-align -Wcast-qual -Wshadow -Wwrite-strings
        "$<$<COMPILE_LANGUAGE:C>:-Wstrict-prototypes;-Wmissing-prototypes;-Wnested-externs;-Wbad-function-cast>")
endif()

#
# Add GNUInstallDirs for GNU infrastructure before target)include_directories
#

if(CMAKE_SYSTEM_NAME MATCHES "^(Linux|kFreeBSD|GNU)$" AND NOT CMAKE_CROSSCOMPILING)
    include(GNUInstallDirs)
endif()

#
# Declare PKGINCLUDEDIR for kissfft include path
#

set(PKGINCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/kissfft")
message(STATUS "PKGINCLUDEDIR is ${PKGINCLUDEDIR}")

#
# Declare kissfft library ( libkissfft.a / libkissfft-${KISSFFT_DATATYPE}.so.${MAKEFILE_EXTRACTED_VERSION} )
#

add_library(kissfft
  kiss_fft.c
  kfc.c
  kiss_fftnd.c
  kiss_fftndr.c
  kiss_fftr.c)

target_include_directories(kissfft PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${PKGINCLUDEDIR}>)

#
# Set compile definitions based on datatype and additional support flags
#

set(KISSFFT_COMPILE_DEFINITIONS)

#
# double / float
#

if(KISSFFT_DATATYPE MATCHES "^float$" OR KISSFFT_DATATYPE MATCHES "^double$")
    list(APPEND KISSFFT_COMPILE_DEFINITIONS kiss_fft_scalar=${KISSFFT_DATATYPE})
else()

    #
    # int16_t
    #

    if(KISSFFT_DATATYPE MATCHES "^int16_t$")
        list(APPEND KISSFFT_COMPILE_DEFINITIONS FIXED_POINT=16)
    else()

        #
        # int32_t
        #

        if(KISSFFT_DATATYPE MATCHES "^int32_t$")
            list(APPEND KISSFFT_COMPILE_DEFINITIONS FIXED_POINT=32)
        else()

            #
            # simd
            #

            if(KISSFFT_DATATYPE MATCHES "^simd$")
                list(APPEND KISSFFT_COMPILE_DEFINITIONS USE_SIMD)
                if (NOT MSVC)
                    target_compile_options(kissfft PRIVATE -msse)
                else()
                    target_compile_options(kissfft PRIVATE "/arch:SSE")
                endif()
            endif()
        endif()
    endif()
endif()

#
# OpenMP support
#

if(KISSFFT_OPENMP)
    if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang|AppleClang")
        if (NOT MSVC)
            target_compile_options(kissfft PRIVATE -fopenmp)
            if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
                target_link_libraries(kissfft PRIVATE "-fopenmp")
            else()
                target_link_options(kissfft PRIVATE -fopenmp)
            endif()
        else()
            target_compile_options(kissfft PRIVATE "/openmp")
            if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
                target_link_libraries(kissfft PRIVATE "/openmp")
            else()
                target_link_options(kissfft PRIVATE "/openmp")
            endif()
        endif()
        set(KISSFFT_EXPORT_SUFFIX "-openmp")
        set(KISSFFT_OUTPUT_NAME "kissfft-${KISSFFT_DATATYPE}-openmp")
    else()
        message(FATAL_ERROR "Don't know how to enable OpenMP for this compiler")
    endif()
endif()

#
# Shared / static library
#

if(NOT KISSFFT_STATIC)
    list(APPEND KISSFFT_COMPILE_DEFINITIONS KISS_FFT_SHARED)
    set_target_properties(kissfft PROPERTIES
        C_VISIBILITY_PRESET hidden)
    set(KISSFFT_EXPORT_SUFFIX "${KISSFFT_EXPORT_SUFFIX}-shared")
else()
    set(KISSFFT_EXPORT_SUFFIX "${KISSFFT_EXPORT_SUFFIX}-static")
endif()

#
# Alloca support
#

if(KISSFFT_USE_ALLOCA)
    list(APPEND KISSFFT_COMPILE_DEFINITIONS KISS_FFT_USE_ALLOCA)
endif()

# Set library name, version, soversion and aliases

target_compile_definitions(kissfft PUBLIC ${KISSFFT_COMPILE_DEFINITIONS})
set_target_properties(kissfft PROPERTIES
    OUTPUT_NAME "${KISSFFT_OUTPUT_NAME}"
    DEFINE_SYMBOL KISS_FFT_BUILD
    EXPORT_NAME "${KISSFFT_OUTPUT_NAME}"
    VERSION ${PROJECT_VERSION}
    SOVERSION ${KFVER_MAJOR})
add_library(kissfft::kissfft ALIAS kissfft)
add_library(kissfft::kissfft-${KISSFFT_DATATYPE} ALIAS kissfft)

#
# Build with libm (-lm) on Linux and kFreeBSD
#

if(CMAKE_SYSTEM_NAME MATCHES "^(Linux|kFreeBSD|GNU)$" AND NOT CMAKE_CROSSCOMPILING)
    target_link_libraries(kissfft PRIVATE m)
endif()

#
# Define a helper function to define executable file
#

function(add_kissfft_executable NAME)
    add_executable(${NAME} ${ARGN})
    target_link_libraries(${NAME} PRIVATE kissfft::kissfft)

    #
    # Build with libm (-lm) on Linux and kFreeBSD
    #

    if(CMAKE_SYSTEM_NAME MATCHES "^(Linux|kFreeBSD|GNU)$" AND NOT CMAKE_CROSSCOMPILING)
        target_link_libraries(${NAME} PRIVATE m)
    endif()

    if (NOT KISSFFT_OPENMP)
        set_target_properties(${NAME} PROPERTIES
            OUTPUT_NAME "${NAME}-${KISSFFT_DATATYPE}")
    else()
        if (NOT MSVC)
            target_compile_options(${NAME} PRIVATE -fopenmp)
            if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
                target_link_libraries(${NAME} PRIVATE "-fopenmp")
            else()
                target_link_options(${NAME} PRIVATE -fopenmp)
            endif()
        else()
            target_compile_options(${NAME} PRIVATE "/openmp")
            if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
                target_link_libraries(${NAME} PRIVATE "/openmp")
            else()
                target_link_options(${NAME} PRIVATE "/openmp")
            endif()
        endif()
        set_target_properties(${NAME} PROPERTIES
            OUTPUT_NAME "${NAME}-${KISSFFT_DATATYPE}-openmp")
    endif()
endfunction()

#
# Perform installation of kissfft library and development files
# Only install when kissfft is the top-level project
#

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  install(TARGETS kissfft EXPORT kissfft
      ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
      LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
      RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

  install(FILES kiss_fft.h
                kissfft.hh
                kiss_fftnd.h
                kiss_fftndr.h
                kiss_fftr.h
          DESTINATION "${PKGINCLUDEDIR}")

  set(KISSFFT_INSTALL_CMAKE "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
      CACHE FILEPATH "Install destination of kissfft cmake modules")
  mark_as_advanced(KISSFFT_INSTALL_CMAKE)

  install(EXPORT kissfft DESTINATION "${KISSFFT_INSTALL_CMAKE}"
          NAMESPACE "kissfft::"
          FILE "${PROJECT_NAME}-${KISSFFT_DATATYPE}${KISSFFT_EXPORT_SUFFIX}-targets.cmake")
  include(CMakePackageConfigHelpers)
  configure_package_config_file(kissfft-config.cmake.in kissfft-config.cmake
      INSTALL_DESTINATION "${KISSFFT_INSTALL_CMAKE}")
  write_basic_package_version_file(kissfft-config-version.cmake COMPATIBILITY AnyNewerVersion)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kissfft-config.cmake" "${CMAKE_CURRENT_BINARY_DIR}/kissfft-config-version.cmake"
          DESTINATION "${KISSFFT_INSTALL_CMAKE}")

  set(PKG_KISSFFT_DEFS)
  foreach(_def ${KISSFFT_COMPILE_DEFINITIONS})
      set(PKG_KISSFFT_DEFS "${PKG_KISSFFT_DEFS} -D${_def}")
  endforeach()
  if (KISSFFT_PKGCONFIG)
      include(JoinPaths)
      set(PKGCONFIG_KISSFFT_PKGINCLUDEDIR "\${includedir}/kissfft")
      set(PKGCONFIG_KISSFFT_PREFIX "${CMAKE_INSTALL_PREFIX}")
      set(PKGCONFIG_KISSFFT_VERSION "${kissfft_VERSION}")
      join_paths(PKGCONFIG_KISSFFT_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")
      join_paths(PKGCONFIG_KISSFFT_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
      if(KISSFFT_DATATYPE MATCHES "^simd$")
         list(APPEND KISSFFT_COMPILE_DEFINITIONS USE_SIMD)
         if (NOT MSVC)
             set(PKG_KISSFFT_DEFS "${PKG_KISSFFT_DEFS} -msse")
         else()
             set(PKG_KISSFFT_DEFS "${PKG_KISSFFT_DEFS} /ARCH:SSE")
         endif()
      endif()
      if (NOT KISSFFT_OPENMP)
          configure_file(kissfft.pc.in "kissfft-${KISSFFT_DATATYPE}.pc" @ONLY)
          install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kissfft-${KISSFFT_DATATYPE}.pc"
                  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
      else()
          if (NOT MSVC)
              set(PKG_OPENMP "-fopenmp")
              set(PKG_KISSFFT_DEFS "${PKG_KISSFFT_DEFS} -fopenmp")
          else()
              set(PKG_KISSFFT_DEFS "${PKG_KISSFFT_DEFS} /openmp")
              set(PKG_OPENMP "/openmp")
          endif()
          configure_file(kissfft.pc.in "kissfft-${KISSFFT_DATATYPE}-openmp.pc" @ONLY)
          install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kissfft-${KISSFFT_DATATYPE}-openmp.pc"
                  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
      endif()
  endif()
endif()

#
# Build and install tools if requested by user
#

if(KISSFFT_TOOLS)
    add_subdirectory(tools)
endif()

#
# Build and run tests if requested by user
#

if(KISSFFT_TEST)
    enable_testing()
    add_subdirectory(test)
endif()

=== lib/OpenSSL/CMakeLists.txt ===
#
# Copyright (c) 2024 Alex Spataru <https://github.com/alex-spataru>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

cmake_minimum_required(VERSION 3.20)

function(target_link_openssl TARGET BASE_DIR)
  if(WIN32)
    target_include_directories(${TARGET} PRIVATE ${BASE_DIR}/include)
    target_compile_definitions(${TARGET} PRIVATE OPENSSL_USE_STATIC_LIBS)

    if(MSVC)
      target_link_libraries(${TARGET} PRIVATE
        ws2_32
        gdi32
        advapi32
        crypt32
        user32
        ${BASE_DIR}/dll/Windows/msvc/libssl.lib
        ${BASE_DIR}/dll/Windows/msvc/libcrypto.lib
      )
    elseif(MINGW)
      target_link_libraries(${TARGET} PRIVATE
        ws2_32
        gdi32
        advapi32
        crypt32
        user32
        ${BASE_DIR}/dll/Windows/mingw/libssl.a
        ${BASE_DIR}/dll/Windows/mingw/libcrypto.a
      )
    else()
      message(FATAL_ERROR "Unsupported Windows compiler — only MSVC and MinGW are handled.")
    endif()

  elseif(APPLE)
    target_include_directories(${TARGET} PRIVATE ${BASE_DIR}/include)
    target_compile_definitions(${TARGET} PRIVATE OPENSSL_USE_STATIC_LIBS)
    target_link_libraries(${TARGET} PRIVATE
      ${BASE_DIR}/dll/macOS/libssl.a
      ${BASE_DIR}/dll/macOS/libcrypto.a
    )

  elseif(UNIX)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(OPENSSL REQUIRED openssl)
    target_link_libraries(${TARGET} PRIVATE ${OPENSSL_LIBRARIES})
    target_include_directories(${TARGET} PRIVATE ${OPENSSL_INCLUDE_DIRS})
    target_compile_options(${TARGET} PRIVATE ${OPENSSL_CFLAGS_OTHER})
  endif()
endfunction()

=== lib/mdflib/CMakeLists.txt ===
# Copyright 2021 Ingemar Hedvall
# SPDX-License-Identifier: MIT
include(CMakePrintHelpers)
cmake_minimum_required(VERSION 3.15)
cmake_policy(SET CMP0074 NEW)
cmake_policy(SET CMP0091 NEW)
cmake_policy(SET CMP0167 NEW)

#cmake_policy(SET CMP0144 NEW)
if("${CMAKE_TOOLCHAIN_FILE}" STREQUAL "")
  set(VCPKG OFF)
else()
  set(VCPKG ON)
endif()


option(BUILD_SHARED_LIBS "Build static library as default." OFF)
option(MDF_BUILD_SHARED_LIB "Build shared library." OFF)
option(MDF_BUILD_SHARED_LIB_NET "Build shared library with .NET." OFF) # Only for MSVC 19.36+
option(MDF_BUILD_SHARED_LIB_EXAMPLE "Build shared library example." OFF)
option(MDF_BUILD_DOC "Build documentation. Requires Doxygen and Release mode." OFF)
option(MDF_BUILD_TOOL "Build tools like the MDF Viewer. Requires WxWidgets." OFF)
option(MDF_BUILD_TEST "Build Google Unit Tests. Requires Google Test." OFF)
option(MDF_BUILD_PYTHON "Build Python module" OFF)

if(MDF_BUILD_TOOL AND VCPKG)
  list(APPEND VCPKG_MANIFEST_FEATURES "mdf2csv")
  list(APPEND VCPKG_MANIFEST_FEATURES "mdfviewer")
endif()

if(MDF_BUILD_TEST AND VCPKG)
  list(APPEND VCPKG_MANIFEST_FEATURES "mdflibtest")
endif()



# set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>") # for static runtime

project(
  mdflib
  VERSION 2.3
  DESCRIPTION "Interface against MDF 3/4 files"
  LANGUAGES CXX)
  
add_subdirectory(mdflib)

if(MDF_BUILD_SHARED_LIB)
  if(NOT (MSVC AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 19.36))
    set(MDF_BUILD_SHARED_LIB_NET OFF)
  endif()
  add_subdirectory(mdflibrary)
endif()

if(MDF_BUILD_TEST)
  enable_testing()
  add_subdirectory(mdflib_test)
endif()

if(MDF_BUILD_SHARED_LIB AND MDF_BUILD_SHARED_LIB_EXAMPLE)
  add_subdirectory(mdflibrary_example)
endif()

if(MDF_BUILD_TOOL)
  add_subdirectory(mdf2csv)
  add_subdirectory(mdfviewer)
endif()

if (MDF_BUILD_PYTHON)
  find_package(Python3 COMPONENTS Interpreter Development)
  cmake_print_properties(TARGETS Python3::Python PROPERTIES
          NAME
          LOCATION
          INTERFACE_INCLUDE_DIRECTORIES)

  cmake_print_variables(
          Python3_FOUND
          Python3_INCLUDE_DIRS
          Python3_RUNTIME_LIBRARY_DIRS)
  include("script/pybind11.cmake")
  add_subdirectory(python)
endif()

if((CMAKE_BUILD_TYPE MATCHES "^[Rr]elease") AND MDF_BUILD_DOC)
  include("script/doxygen.cmake")
  if(DOXYGEN_FOUND)
    set(DOXYGEN_RECURSIVE NO)
    set(DOXYGEN_REPEAT_BRIEF NO)
    set(DOXYGEN_PROJECT_NAME "MDF Lib")
    set(DOXYGEN_PROJECT_NUMBER "2.3")
    set(DOXYGEN_HTML_EXTRA_STYLESHEET doxygen/utillib.css)
    set(DOXYGEN_OUTPUT_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/docs/manual)
    doxygen_add_docs(
      doc_libmdf ALL include/mdf doxygen
      COMMENT "MDF Library generating API documentation with Doxygen")
  endif()
endif()

# ##############################################################################
# Packaging
# ##############################################################################
# Only export and install when mdflib is the top-level project
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  # https://cmake.org/cmake/help/latest/manual/cmake-packages.7.html#creating-a-package-configuration-file
  include(CMakePackageConfigHelpers)
  write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/mdflib/mdflibConfigVersion.cmake"
    VERSION ${Upstream_VERSION}
    COMPATIBILITY AnyNewerVersion)

  export(
    EXPORT MdfLibTargets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/mdflib/mdflibTargets.cmake"
    NAMESPACE Upstream::)
  configure_file(cmake/MdfLibConfig.cmake
                 "${CMAKE_CURRENT_BINARY_DIR}/mdflib/MdfLibConfig.cmake" COPYONLY)

  set(ConfigPackageLocation lib/cmake/mdflib)
  install(
    EXPORT MdfLibTargets
    FILE MdfLibTargets.cmake
    NAMESPACE Upstream::
    DESTINATION ${ConfigPackageLocation})
  install(
    FILES cmake/MdfLibConfig.cmake
          "${CMAKE_CURRENT_BINARY_DIR}/mdflib/mdflibConfigVersion.cmake"
    DESTINATION ${ConfigPackageLocation}
    COMPONENT Devel)
endif()

=== lib/mdflib/mdf2csv/CMakeLists.txt ===
# Copyright 2024 Ingemar Hedvall
# SPDX-License-Identifier: MIT

project(MdfToCsv
        VERSION 1.0
        DESCRIPTION "Converts an MDF file to one or more CSV files"
        LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)

if (MDF_BUILD_TEST)
    add_subdirectory(test)
endif()

add_executable(mdf2csv
    src/main.cpp
        src/programargument.cpp
        src/programargument.h
        src/createfilelist.cpp
        src/createfilelist.h
        src/csvwriter.cpp
        src/csvwriter.h
        src/logtoconsole.cpp
        src/logtoconsole.h)

target_include_directories(mdf2csv PRIVATE ${XTENSOR_INCLUDE_DIRS})

if(MSVC)
    target_compile_definitions(mdf2csv PRIVATE
            _WIN32_WINNT=0x0A00
            _SILENCE_ALL_CXX17_DEPRECATION_WARNINGS
            _CRT_SECURE_NO_WARNINGS
            _SILENCE_CXX20_U8PATH_DEPRECATION_WARNING)
elseif(MINGW)
    target_link_options(mdf2csv PRIVATE -mwindows -static -fstack-protector)
endif()

target_link_libraries(mdf2csv PRIVATE mdf)


if(VCPKG)
    find_package(Boost CONFIG REQUIRED COMPONENTS program_options)
    target_link_libraries(mdf2csv PRIVATE Boost::program_options)
else()
    include("../script/boost.cmake")

    target_include_directories(mdf2csv PRIVATE ${Boost_INCLUDE_DIRS})

    target_link_libraries(mdf2csv PRIVATE ${Boost_LIBRARIES})
endif()

if(WIN32)
  install(
    TARGETS mdf2csv
    EXPORT Mdf2CsvTargets
    LIBRARY DESTINATION mdf2csv/lib
    ARCHIVE DESTINATION mdf2csv/lib
    RUNTIME DESTINATION mdf2csv/bin
    PUBLIC_HEADER DESTINATION mdf2csv/include/mdf2csv)
else()
  install(
    TARGETS mdf2csv
    EXPORT Mdf2CsvTargets
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
    RUNTIME DESTINATION bin
    PUBLIC_HEADER DESTINATION include/mdf2csv)
endif()

if(WIN32)
    install(
            TARGETS mdf2csv
            EXPORT MdfViewTargets
            LIBRARY DESTINATION mdf/lib
            ARCHIVE DESTINATION mdf/lib
            RUNTIME DESTINATION mdf/bin
            PUBLIC_HEADER DESTINATION mdf/include/mdf)
else()
    install(
            TARGETS mdf2csv
            EXPORT MdfViewTargets
            LIBRARY DESTINATION lib
            ARCHIVE DESTINATION lib
            RUNTIME DESTINATION bin
            PUBLIC_HEADER DESTINATION include/mdf)
endif()

=== lib/mdflib/mdflib/CMakeLists.txt ===
# Copyright 2023 Simplxs
# SPDX-License-Identifier: MIT

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_DEBUG_POSTFIX d)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ${BUILD_SHARED_LIBS})

add_library(mdf
        src/mdfblock.cpp src/mdfblock.h
        src/mdffile.cpp ../include/mdf/mdffile.h
        src/idblock.cpp src/idblock.h
        src/hd3block.cpp src/hd3block.h
        src/tx3block.cpp src/tx3block.h
        src/pr3block.cpp src/pr3block.h
        src/tr3block.cpp src/tr3block.h
        src/sr3block.cpp src/sr3block.h
        src/dg3block.cpp src/dg3block.h
        src/cg3block.cpp src/cg3block.h
        src/cn3block.cpp src/cn3block.h
        src/cc3block.cpp src/cc3block.h
        src/cd3block.cpp src/cd3block.h
        src/ce3block.cpp src/ce3block.h
        src/mdfreader.cpp ../include/mdf/mdfreader.h
        src/mdf3file.cpp src/mdf3file.h
        src/hd4block.cpp src/hd4block.h
        src/tx4block.cpp src/tx4block.h
        src/md4block.cpp src/md4block.h
        src/fh4block.cpp src/fh4block.h
        src/ch4block.cpp src/ch4block.h
        src/at4block.cpp src/at4block.h
        src/ev4block.cpp src/ev4block.h
        src/dg4block.cpp src/dg4block.h
        src/cg4block.cpp src/cg4block.h
        src/si4block.cpp src/si4block.h
        src/cn4block.cpp src/cn4block.h
        src/cc4block.cpp src/cc4block.h
        src/ca4block.cpp src/ca4block.h
        src/dt4block.cpp src/dt4block.h
        src/sr4block.cpp src/sr4block.h
        src/rd4block.cpp src/rd4block.h
        src/sd4block.cpp src/sd4block.h
        src/dl4block.cpp src/dl4block.h
        src/dz4block.cpp src/dz4block.h
        src/hl4block.cpp src/hl4block.h
        src/mdf4file.cpp src/mdf4file.h
        src/datablock.cpp src/datablock.h
        src/datalistblock.cpp src/datalistblock.h
        src/blockproperty.cpp src/blockproperty.h
        src/mdf4timestamp.cpp src/mdf4timestamp.h
        src/iattachment.cpp ../include/mdf/iattachment.h
        ../include/mdf/ichannel.h src/ichannel.cpp
        ../include/mdf/idatagroup.h src/idatagroup.cpp
        ../include/mdf/ichannelgroup.h src/ichannelgroup.cpp
        src/channelobserver.h src/channelobserver.cpp
        ../include/mdf/ichannelobserver.h src/ichannelobserver.cpp
        ../include/mdf/ichannelconversion.h src/ichannelconversion.cpp
        src/mdf3writer.h src/mdf3writer.cpp
        src/dt3block.cpp src/dt3block.h
        src/iheader.cpp ../include/mdf/iheader.h
        ../include/mdf/samplerecord.h
        src/mdf4writer.cpp src/mdf4writer.h
        src/mdfwriter.cpp ../include/mdf/mdfwriter.h
        src/mdffactory.cpp ../include/mdf/mdffactory.h
        src/ifilehistory.cpp ../include/mdf/ifilehistory.h
        src/imetadata.cpp ../include/mdf/imetadata.h
        src/etag.cpp ../include/mdf/etag.h
        src/ievent.cpp ../include/mdf/ievent.h
        src/ichannelhierarchy.cpp ../include/mdf/ichannelhierarchy.h
        src/isourceinformation.cpp ../include/mdf/isourceinformation.h
        src/ichannelarray.cpp ../include/mdf/ichannelarray.h
        src/mdfhelper.cpp ../include/mdf/mdfhelper.h
        src/dv4block.cpp src/dv4block.h
        src/di4block.cpp src/di4block.h
        src/rv4block.cpp src/rv4block.h
        src/ri4block.cpp src/ri4block.h
        src/ld4block.cpp src/ld4block.h
        src/cryptoutil.cpp ../include/mdf/cryptoutil.h
        src/zlibutil.cpp ../include/mdf/zlibutil.h
        src/ixmlfile.cpp src/ixmlfile.h
        src/ixmlnode.cpp src/ixmlnode.h
        src/writexml.cpp src/writexml.h
        src/xmlnode.cpp src/xmlnode.h
        src/expatxml.cpp src/expatxml.h
        src/mdflogstream.cpp ../include/mdf/mdflogstream.h
        src/littlebuffer.cpp src/littlebuffer.h
        src/bigbuffer.cpp src/bigbuffer.h
        src/platform.cpp src/platform.h
        src/iblock.cpp ../include/mdf/iblock.h
        src/vlsddata.cpp src/vlsddata.h
        src/mdfbuslogger.cpp src/mdfbuslogger.h
        src/canmessage.cpp ../include/mdf/canmessage.h
        src/dbchelper.cpp src/dbchelper.h
        src/isampleobserver.cpp  ../include/mdf/isampleobserver.h
        src/isamplereduction.cpp ../include/mdf/isamplereduction.h
        src/readcache.cpp src/readcache.h
        src/dgrange.cpp src/dgrange.h
        src/cgrange.cpp src/cgrange.h
        src/mdfconverter.cpp src/mdfconverter.h
        src/timestamp.cpp  ../include/mdf/imdftimestamp.h
        src/mdf3timestamp.cpp src/mdf3timestamp.h
        src/linmessage.cpp ../include/mdf/linmessage.h
        src/linconfigadapter.cpp ../include/mdf/linconfigadapter.h
        src/ethmessage.cpp ../include/mdf/ethmessage.h
        src/ethconfigadapter.cpp ../include/mdf/ethconfigadapter.h
        src/writecache.cpp src/writecache.h
        src/samplequeue.cpp src/samplequeue.h
        src/writer4samplequeue.cpp src/writer4samplequeue.h
        src/convertersamplequeue.cpp src/convertersamplequeue.h
        src/mdcomment.cpp ../include/mdf/mdcomment.h
        src/mdstandardattribute.cpp ../include/mdf/mdstandardattribute.h
        src/mdproperty.cpp ../include/mdf/mdproperty.h
        src/mdlist.cpp ../include/mdf/mdlist.h
        src/mdenumerate.cpp ../include/mdf/mdenumerate.h
        src/mdstring.cpp ../include/mdf/mdstring.h
        src/mdalternativename.cpp ../include/mdf/mdalternativename.h
        src/mdformula.cpp ../include/mdf/mdformula.h
        src/mdsyntax.cpp ../include/mdf/mdsyntax.h
        src/mdvariable.cpp ../include/mdf/mdvariable.h
        src/mdextension.cpp ../include/mdf/mdextension.h
        src/hdcomment.cpp ../include/mdf/hdcomment.h
        src/hounitspecification.cpp ../include/mdf/hounitspecification.h
        src/hoadmindata.cpp ../include/mdf/hoadmindata.h
        src/horevision.cpp ../include/mdf/horevision.h
        src/honamedetails.cpp ../include/mdf/honamedetails.h
        src/hophysicaldimension.cpp ../include/mdf/hophysicaldimension.h
        src/hounitgroup.cpp ../include/mdf/hounitgroup.h
        src/hounit.cpp ../include/mdf/hounit.h
        src/hointerval.cpp ../include/mdf/hointerval.h
        src/fhcomment.cpp ../include/mdf/fhcomment.h
        src/chcomment.cpp ../include/mdf/chcomment.h
        src/atcomment.cpp ../include/mdf/atcomment.h
        src/mdnumber.cpp ../include/mdf/mdnumber.h
        src/evcomment.cpp ../include/mdf/evcomment.h
        src/dgcomment.cpp ../include/mdf/dgcomment.h
        src/cgcomment.cpp ../include/mdf/cgcomment.h
        src/sicomment.cpp ../include/mdf/sicomment.h
        src/cncomment.cpp ../include/mdf/cncomment.h
        src/hocompumethod.cpp ../include/mdf/hocompumethod.h
        src/hoenumerates.cpp ../include/mdf/hoenumerates.h
        src/hoscaleconstraint.cpp ../include/mdf/hoscaleconstraint.h
        src/hocompuscale.cpp ../include/mdf/hocompuscale.h
        src/cccomment.cpp ../include/mdf/cccomment.h
        src/ccunit.cpp
        ../include/mdf/ccunit.h
        src/cnunit.cpp
        ../include/mdf/cnunit.h
        src/iconfigadapter.cpp
        ../include/mdf/iconfigadapter.h
        src/canconfigadapter.cpp
        ../include/mdf/canconfigadapter.h
        ../include/mdf/mdfenumerates.h
        src/mdfenumerates.cpp
        src/mostmessage.cpp
        ../include/mdf/mostmessage.h
        src/mostconfigadapter.cpp
        ../include/mdf/mostconfigadapter.h
        src/flexraymessage.cpp
        ../include/mdf/flexraymessage.h
        src/flexrayconfigadapter.cpp
        ../include/mdf/flexrayconfigadapter.h
        src/canbusobserver.cpp
        ../include/mdf/canbusobserver.h
)

set(CMAKE_POSITION_INDEPENDENT_CODE ${BUILD_SHARED_LIBS})

if(TARGET ZLIB::ZLIB AND TARGET expat::expat)
  target_link_libraries(mdf PRIVATE ZLIB::ZLIB expat::expat)
  target_compile_definitions(mdf PRIVATE XML_STATIC)
elseif(VCPKG)
  find_package(ZLIB REQUIRED)
  target_link_libraries(mdf PRIVATE ZLIB::ZLIB)

  find_package(expat CONFIG REQUIRED)
  target_link_libraries(mdf PRIVATE expat::expat)
else()
  include("../script/zlib.cmake")
  include("../script/expat.cmake")

  target_include_directories(mdf PRIVATE ${ZLIB_INCLUDE_DIRS})
  target_include_directories(mdf PRIVATE ${EXPAT_INCLUDE_DIRS})

  target_compile_definitions(mdf PRIVATE XML_STATIC)
  target_link_libraries(mdf ${ZLIB_LIBRARIES} ${EXPAT_LIBRARIES})
endif()

target_include_directories(
  mdf PUBLIC
    $<INSTALL_INTERFACE:include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
)

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  set_target_properties(mdf PROPERTIES COMPILE_FLAGS "-fPIC")
elseif(MSVC)
  target_compile_definitions(mdf PRIVATE _SILENCE_ALL_CXX17_DEPRECATION_WARNINGS _CRT_SECURE_NO_WARNINGS)
endif()

set(MDF_PUBLIC_HEADERS
    ../include/mdf/atcomment.h
    ../include/mdf/canconfigadapter.h
    ../include/mdf/canmessage.h
    ../include/mdf/cccomment.h
    ../include/mdf/ccunit.h
    ../include/mdf/cgcomment.h
    ../include/mdf/chcomment.h
    ../include/mdf/cncomment.h
    ../include/mdf/cnunit.h
    ../include/mdf/cryptoutil.h
    ../include/mdf/dgcomment.h
    ../include/mdf/etag.h
    ../include/mdf/ethconfigadapter.h
    ../include/mdf/ethmessage.h
    ../include/mdf/evcomment.h
    ../include/mdf/fhcomment.h
    ../include/mdf/flexrayconfigadapter.h
    ../include/mdf/flexraymessage.h
    ../include/mdf/hdcomment.h
    ../include/mdf/hoadmindata.h
    ../include/mdf/hocompumethod.h
    ../include/mdf/hocompuscale.h
    ../include/mdf/hoenumerates.h
    ../include/mdf/hointerval.h
    ../include/mdf/honamedetails.h
    ../include/mdf/hophysicaldimension.h
    ../include/mdf/horevision.h
    ../include/mdf/hoscaleconstraint.h
    ../include/mdf/hounit.h
    ../include/mdf/hounitgroup.h
    ../include/mdf/hounitspecification.h
    ../include/mdf/iattachment.h
    ../include/mdf/iblock.h
    ../include/mdf/ichannel.h
    ../include/mdf/ichannelarray.h
    ../include/mdf/ichannelconversion.h
    ../include/mdf/ichannelgroup.h
    ../include/mdf/ichannelhierarchy.h
    ../include/mdf/ichannelobserver.h
    ../include/mdf/iconfigadapter.h
    ../include/mdf/idatagroup.h
    ../include/mdf/ievent.h
    ../include/mdf/ifilehistory.h
    ../include/mdf/iheader.h
    ../include/mdf/imdftimestamp.h
    ../include/mdf/imetadata.h
    ../include/mdf/isampleobserver.h
    ../include/mdf/isourceinformation.h
    ../include/mdf/itimestamp.h
    ../include/mdf/linconfigadapter.h
    ../include/mdf/linmessage.h
    ../include/mdf/mdalternativename.h
    ../include/mdf/mdcomment.h
    ../include/mdf/mdenumerate.h
    ../include/mdf/mdextension.h
    ../include/mdf/mdfenumerates.h
    ../include/mdf/mdffactory.h
    ../include/mdf/mdffile.h
    ../include/mdf/mdfhelper.h
    ../include/mdf/mdflogstream.h
    ../include/mdf/mdformula.h
    ../include/mdf/mdfreader.h
    ../include/mdf/mdfwriter.h
    ../include/mdf/mdlist.h
    ../include/mdf/mdnumber.h
    ../include/mdf/mdproperty.h
    ../include/mdf/mdstandardattribute.h
    ../include/mdf/mdstring.h
    ../include/mdf/mdsyntax.h
    ../include/mdf/mdvariable.h
    ../include/mdf/mostconfigadapter.h
    ../include/mdf/mostmessage.h
    ../include/mdf/isamplereduction.h
    ../include/mdf/samplerecord.h
    ../include/mdf/sicomment.h
    ../include/mdf/zlibutil.h)
set_target_properties(mdf PROPERTIES PUBLIC_HEADER "${MDF_PUBLIC_HEADERS}")
get_target_property(PH1 mdf PUBLIC_HEADER)
message(STATUS "MDF Target Includes: " "${PH1}")

# Only install when mdflib is the top-level project
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  if(WIN32)
    install(
      TARGETS mdf
      EXPORT MdfLibTargets
      LIBRARY DESTINATION mdf/lib
      ARCHIVE DESTINATION mdf/lib
      RUNTIME DESTINATION mdf/bin
      PUBLIC_HEADER DESTINATION mdf/include/mdf)
  else()
    install(
      TARGETS mdf
      EXPORT MdfLibTargets
      LIBRARY DESTINATION lib
      ARCHIVE DESTINATION lib
      RUNTIME DESTINATION bin
      PUBLIC_HEADER DESTINATION include/mdf)
  endif()
endif()

=== lib/mdflib/mdflib_test/CMakeLists.txt ===
# Copyright 2021 Ingemar Hedvall
# SPDX-License-Identifier: MIT


project(
  TestMdf
  VERSION 1.0
  DESCRIPTION "Google unit tests for the mdf library"
  LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)

include(../script/utillib.cmake)

add_executable(test_mdf
        src/main.cpp
        src/testcrypto.cpp
        src/testread.cpp src/testread.h
        src/testwrite.cpp src/testwrite.h
        src/testmdffile.cpp
        src/testmetadata.cpp src/testmetadata.h
        src/testzlib.cpp src/testzlib.h
        src/testhelper.cpp
        src/testchannel.cpp
        src/testchannelarray.cpp
        src/testchannelarray.h
        src/testqueue.cpp
        src/testiostream.cpp
        src/testmdfblock.cpp
        src/testbuslogger.cpp
        src/testbuslogger.h
        src/testmultipledgwrite.cpp
        src/testmultipledgwrite.h
        src/testtimestamp.cpp
        src/testtimestamp.h
        src/testhdcomment.cpp
        src/testcccomment.cpp
        src/testcncomment.cpp
        src/testevcomment.cpp
        src/testfhcomment.cpp
        src/testsicomment.cpp
        src/testmostlogger.cpp
        src/testmostlogger.h
        src/testflexraylogger.cpp
        src/testflexraylogger.h
        src/testlinlogger.cpp
        src/testlinlogger.h
        src/testethlogger.cpp
        src/testethlogger.h
        src/testcanbusobserver.cpp
        src/testcanbusobserver.h
        src/testmdfwriter.cpp
        src/testwrite3.cpp
        src/testwrite3.h
        src/testreadvlsd.cpp
        src/testreadvlsd.h)

target_include_directories(test_mdf PRIVATE ../include ../mdflib/src)
target_include_directories(test_mdf PRIVATE ${utillib_SOURCE_DIR}/include)

if(VCPKG)
  find_package(Boost REQUIRED CONFIG COMPONENTS endian filesystem system process locale)
  target_link_libraries(test_mdf PRIVATE
          Boost::endian
          Boost::filesystem
          Boost::system
          Boost::process
          Boost::locale
          util)

  find_package(GTest CONFIG REQUIRED)
  target_link_libraries(test_mdf PRIVATE GTest::gtest GTest::gtest_main
                                        GTest::gmock GTest::gmock_main)

else()
  include("../script/googletest.cmake")
  include("../script/boost.cmake")
  target_include_directories(test_mdf PRIVATE ${Boost_INCLUDE_DIRS})

  target_link_libraries(test_mdf PRIVATE util ${Boost_LIBRARIES})

  target_link_libraries(test_mdf PRIVATE GTest::gtest GTest::gtest_main)
endif()

if(MSVC)
  target_compile_definitions(test_mdf PRIVATE _SILENCE_ALL_CXX17_DEPRECATION_WARNINGS _CRT_SECURE_NO_WARNINGS)
endif()

target_link_libraries(test_mdf PRIVATE Boost::filesystem)
target_link_libraries(test_mdf PRIVATE Boost::process)
target_link_libraries(test_mdf PRIVATE sago::platform_folders)
target_link_libraries(test_mdf PRIVATE mdf)

include(GoogleTest)
gtest_discover_tests(test_mdf)

=== lib/mdflib/mdflibrary/CMakeLists.txt ===
# Copyright 2023 Simplxs
# SPDX-License-Identifier: MIT
project(
  mdflibrary
  VERSION 2.1
  DESCRIPTION "Interface against MDF 3/4 files"
  LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_DEBUG_POSTFIX d)

message(STATUS  "Compiler Version " ${CMAKE_CXX_COMPILER_VERSION})
if (MDF_BUILD_SHARED_LIB_NET)
  message(STATUS  "Enable CLR")
  
  # error D8016: '/clr' and '/MT' command-line options are incompatible
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
  add_library(mdflibrary SHARED
            # C++ files
            src/MdfExport.cpp ../include/mdflibrary/MdfExport.h
            
            # Following files are needed for clr
            src/AssemblyInfo.cpp
            src/MdfAttachment.cpp src/MdfAttachment.h
            src/MdfChannel.cpp src/MdfChannel.h
            src/MdfChannelArray.cpp src/MdfChannelArray.h
            src/MdfChannelConversion.cpp src/MdfChannelConversion.h
            src/MdfChannelGroup.cpp src/MdfChannelGroup.h
            src/MdfChannelObserver.cpp src/MdfChannelObserver.h
            src/MdfDataGroup.cpp src/MdfDataGroup.h
            src/MdfETag.cpp src/MdfETag.h
            src/MdfEvent.cpp src/MdfEvent.h
            src/MdfFile.cpp src/MdfFile.h
            src/MdfFileHistory.cpp src/MdfFileHistory.h
            src/MdfHeader.cpp src/MdfHeader.h
            src/mdflibrary.cpp src/mdflibrary.h
            src/MdfMetaData.cpp src/MdfMetaData.h
            src/MdfReader.cpp src/MdfReader.h
            src/MdfSourceInformation.cpp src/MdfSourceInformation.h
            src/Mdfwriter.cpp src/Mdfwriter.h
            src/CanMessage.cpp src/CanMessage.h
            src/MdfNetHelper.cpp src/MdfNetHelper.h
            src/MdfTimestamp.cpp src/MdfTimestamp.h
            src/MdfFileTimestamp.cpp src/MdfFileTimestamp.h
            )
  set_target_properties(mdflibrary PROPERTIES COMMON_LANGUAGE_RUNTIME "")
else()
  add_library(mdflibrary SHARED src/MdfExport.cpp)
endif()

target_link_libraries(mdflibrary PRIVATE mdf)

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 7.3 AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0 AND NOT MINGW)
  # fix for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=90050
  target_link_libraries(mdflibrary PRIVATE pthread stdc++fs)
endif()

target_include_directories(
  mdflibrary PUBLIC $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>)

# Hander files for c/cpp, NOT the SAME as the one of c# clr
set(MDFLIBRARY_PUBLIC_HEADERS
            ../include/mdflibrary/MdfExport.h
            ../include/mdflibrary/MdfAttachment.h
            ../include/mdflibrary/MdfChannel.h
            ../include/mdflibrary/MdfChannelConversion.h
            ../include/mdflibrary/MdfChannelGroup.h
            ../include/mdflibrary/MdfChannelObserver.h
            ../include/mdflibrary/MdfDataGroup.h
            ../include/mdflibrary/MdfETag.h
            ../include/mdflibrary/MdfEvent.h
            ../include/mdflibrary/MdfFile.h
            ../include/mdflibrary/MdfFileHistory.h
            ../include/mdflibrary/MdfHeader.h
            ../include/mdflibrary/MdfMetaData.h
            ../include/mdflibrary/MdfReader.h
            ../include/mdflibrary/MdfSourceInformation.h
            ../include/mdflibrary/MdfWriter.h
            ../include/mdflibrary/CanMessage.h)
set_target_properties(mdflibrary PROPERTIES PUBLIC_HEADER
                                            "${MDFLIBRARY_PUBLIC_HEADERS}")
get_target_property(PH1 mdflibrary PUBLIC_HEADER)
message(STATUS "MDFLibrary Target Includes: " "${PH1}")

if(WIN32)
  install(
    TARGETS mdflibrary
    EXPORT MdfLibraryTargets
    LIBRARY DESTINATION mdflibrary/lib
    ARCHIVE DESTINATION mdflibrary/lib
    RUNTIME DESTINATION mdflibrary/bin
    PUBLIC_HEADER DESTINATION mdflibrary/include/mdflibrary)
else()
  install(
    TARGETS mdflibrary
    EXPORT MdfLibraryTargets
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
    RUNTIME DESTINATION bin
    PUBLIC_HEADER DESTINATION include/mdflibrary)
endif()

=== lib/mdflib/mdflibrary_example/CMakeLists.txt ===
# Copyright 2023 Simplxs
# SPDX-License-Identifier: MIT
project(
  mdflibraryexample
  VERSION 1.0
  DESCRIPTION "MdfLibraryTest"
  LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)

add_executable(mdflibraryexample src/test.cpp)
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  set_target_properties(mdflibraryexample PROPERTIES LINK_FLAGS
                                                  "-Wl,-rpath,'$ORIGIN'")
endif()

target_link_libraries(mdflibraryexample PRIVATE mdflibrary)

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 7.3 AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0 AND NOT MINGW)
  # fix for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=90050
  target_link_libraries(mdflibraryexample PRIVATE pthread stdc++fs)
endif()

target_include_directories(
  mdflibraryexample PUBLIC $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>)

=== PKGBUILD ===
# Maintainer: umarcor <unai.martinezcorral@ehu.eus>

_realname=serial-studio
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.2.1
pkgrel=1
pkgdesc="Multi-purpose serial data visualization & processing program (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url="https://serial-studio.com"
msys2_repository_url="https://github.com/Serial-Studio/Serial-Studio"
license=('spdx:GPL-3.0-only')
groups=("${MINGW_PACKAGE_PREFIX}-eda")
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-qt6-5compat"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-connectivity"
         "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
         "${MINGW_PACKAGE_PREFIX}-qt6-graphs"
         "${MINGW_PACKAGE_PREFIX}-qt6-serialport"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-qt6-location"
  "${MINGW_PACKAGE_PREFIX}-qt6-positioning"
  "${MINGW_PACKAGE_PREFIX}-qt6-svg"
  "${MINGW_PACKAGE_PREFIX}-qt6-tools"
)
source=("https://github.com/${_realname}/${_realname}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        001-fix-build-and-package.patch
        002-no-qt-deployment.patch
        003-armv8.2-a.patch)
sha256sums=('495f3e16ad5ba617599f7d766ceee0b1d73a51d9d0bc69fce6d0ec6b213bf46c'
            '869646eeb5558206520ba107021cb772da0fba97744d257eae7b6b0e28e21e11'
            '637f7a60dfa69983bd41d5047e507c4020b01d1b761805b66f6e1f12e3cb39cb'
            '5b92a375b628e3aa5628e8b9a3f88b2b0cfdc37d3dc39c7a62c53922fff67a2a')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    if patch --dry-run -Rbp1 -i "${srcdir}/${_patch}" > /dev/null 2>&1 ; then
      msg2 "Skipping ${_patch} because it likely was already applied"
    else
      msg2 "Applying ${_patch}"
      patch -Nbp1 -i "${srcdir}/${_patch}"
    fi
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  apply_patch_with_msg \
    001-fix-build-and-package.patch \
    002-no-qt-deployment.patch

  if [[ ${MSYSTEM} == CLANGARM64 ]]; then
    apply_patch_with_msg \
      003-armv8.2-a.patch
  fi
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake -Wno-dev \
      -G"Ninja" \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DPRODUCTION_OPTIMIZATION=ON \
      -DUSE_SYSTEM_ZLIB=ON \
      -DUSE_SYSTEM_EXPAT=ON \
      ${_extra_config[@]} \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

check() {
  "${srcdir}"/build-${MSYSTEM}/app/Serial-Studio-GPL3.exe --help
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.md \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.md
}
